#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "antifib"

const int MaxN = 52;

int f [MaxN] [MaxN];
bool fib [MaxN];
int n;

int main (void)
{
 int i, j, k, s;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);

 memset (fib, 0, sizeof (fib));
 i = 1;
 for (j = i; j < MaxN; k = j, j += i, i = k)
  fib[j] = true;

 memset (f, 0, sizeof (f));
 f[0][1] = 1;
 for (i = 0; i < MaxN; i++)
  for (j = 1; j < MaxN; j++)
   for (k = j; k < MaxN - i; k++)
    if (!fib[k])
     f[i + k][k] += f[i][j];

 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= 1 && n <= 50);
  s = 0;
  if (n >= 16)
   for (j = 1; j < MaxN; j++)
    s += f[n][j];
  printf ("%d\n", s);
 }
 return 0;
}
