#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "bishop"

const int MinN = 1, MaxN = 8, MaxD = 2;

int main (void)
{
 char b, c;
 int x0, y0, x, y;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %c %c", &b, &c) != EOF)
 {
  x0 = b - 'a' + 1;
  y0 = c - '1' + 1;
  assert (x0 >= MinN && x0 <= MaxN);
  assert (y0 >= MinN && y0 <= MaxN);
  for (x = MinN; x <= MaxN; x++)
   for (y = MinN; y <= MaxN; y++)
    if (abs (x - x0) > 0 && abs (x - x0) == abs (y - y0))
     printf ("%c%c\n", x + 'a' - 1, y + '1' - 1);
 }
 return 0;
}
