#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "antifib"

const int MaxN = 52;

bool fib [MaxN];
int n;

int recur (int sum, int num)
{
 if (sum == n) return (!fib[num]);
 if (sum > n) return 0;
 int i, res;
 res = 0;
 for (i = 1; i <= n; i++)
  if (!fib[i])
   res += recur (sum + i, num + 1);
 return res;
}

int main (void)
{
 int i, j, k, s;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);

 memset (fib, 0, sizeof (fib));
 i = 1;
 for (j = i; j < MaxN; k = j, j += i, i = k)
  fib[j] = true;

 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= 1 && n <= 50);
  s = recur (0, 0);
  printf ("%d\n", s);
 }
 return 0;
}
