#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "bishop"

const int MinN = 1, MaxN = 8;

int main (void)
{
 char b, c;
 int e, f, x0, y0, x, y;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %c %c", &b, &c) != EOF)
 {
  x0 = b - 'a' + 1;
  y0 = c - '1' + 1;
  assert (x0 >= MinN && x0 <= MaxN);
  assert (y0 >= MinN && y0 <= MaxN);
  for (e = -MaxN + 1; e < MaxN - 1; e++) if (e)
   for (f = -MaxN + 1; f < MaxN - 1; f++) if (f)
   {
    x = x0 + e;
    y = y0 + f;
    if (x < MinN || x > MaxN) continue;
    if (y < MinN || y > MaxN) continue;
    if (abs (x - x0) > 0 && abs (x - x0) == abs (y - y0))
     printf ("%c%c\n", x + 'a' - 1, y + '1' - 1);
   }
 }
 return 0;
}
